Wt: Wt::Chart::WPieChart Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
Wt::Chart::WPieChart Class Reference
Charts (Wt::Chart) | Model/view system

A pie chart. More...

`#include <Wt/Chart/WPieChart.h>`

Inheritance diagram for Wt::Chart::WPieChart:
[legend]

## Public Member Functions
| WPieChart ()
| Creates a new pie chart.
void | setLabelsColumn (int column)
| Sets the model column that holds the labels.
int | labelsColumn () const
| Returns the model column used for the labels.
void | setDataColumn (int modelColumn)
| Sets the model column that holds the data.
int | dataColumn () const
| Returns the model column used for the data.
void | setBrush (int modelRow, const WBrush &brush)
| Customizes the brush used for a pie segment.
WBrush | brush (int modelRow) const
| Returns the brush used for a pie segment.
void | setExplode (int modelRow, double factor)
| Sets the explosion factor for a pie segment.
double | explode (int modelRow) const
| Returns the explosion factor for a segment.
void | setPerspectiveEnabled (bool enabled, double height=1.0)
| Enables a 3D perspective effect on the pie.
bool | isPerspectiveEnabled () const
| Returns whether a 3D effect is enabled.
void | setShadowEnabled (bool enabled)
| Enables a shadow effect.
bool | isShadowEnabled () const
| Returns whether a shadow effect is enabled.
void | setStartAngle (double degrees)
| Sets the angle of the first segment.
double | startAngle () const
| Returns the angle of the first segment.
void | setAvoidLabelRendering (double percent)
| Sets the percentage value to avoid rendering of label texts.
double | avoidLabelRendering () const
| Returns the percentage to avoid label rendering.
void | setDisplayLabels (WFlags< LabelOption > options)
| Configures if and how labels should be displayed.
WFlags< LabelOption > | displayLabels () const
| Returns options set for displaying labels.
void | setLabelFormat (const WString &format)
| Sets the label format.
WString | labelFormat () const
| Returns the label format string.
std::unique_ptr< WWidget > | createLegendItemWidget (int index, WFlags< LabelOption > options)
| Creates a widget which renders the a legend item.
virtual void | addDataPointArea (int row, int column, std::unique_ptr< WAbstractArea > area) const
| Adds a data point area (used for displaying e.g. tooltips).
virtual std::unique_ptr< WContainerWidget > | createLabelWidget (std::unique_ptr< WWidget > textWidget, WPainter *painter, const WRectF &rect, Wt::WFlags< AlignmentFlag > alignmentFlags) const
| createLabelWidget possition textWidget where the text would be rendered. Assuming that textWidget is added to a container with same dimensions as the WPieChart. This should be used in combinaltion with drawLabel().
virtual void | paint (WPainter &painter, const WRectF &rectangle=WRectF()) const override
| Paint the chart in a rectangle of the given painter.
Public Member Functions inherited from Wt::Chart::WAbstractChart
virtual | ~WAbstractChart ()
| Destructor.
void | setModel (const std::shared_ptr< WAbstractItemModel > &model)
| Sets the model.
void | setModel (const std::shared_ptr< WAbstractChartModel > &model)
| Sets the model.
std::shared_ptr< WAbstractChartModel > | model () const
| Returns the model.
std::shared_ptr< WAbstractItemModel > | itemModel () const
| Returns the model.
void | setBackground (const WBrush &background)
| Sets a background for the chart.
const WBrush & | background () const
| Returns the background of the chart.
void | setPalette (const std::shared_ptr< WChartPalette > &palette)
| Set a palette for the chart.
std::shared_ptr< WChartPalette > | palette () const
| Returns the palette for the chart.
void | setPlotAreaPadding (int padding, WFlags< Side > sides=AllSides)
| Set an internal margin for the main plot area.
int | plotAreaPadding (Side side) const
| Returns the internal margin for the main plot area.
void | setAutoLayoutEnabled (bool enabled=true)
| Configures the chart layout to be automatic.
bool | isAutoLayoutEnabled () const
| Returns whether chart layout is computed automatically.
void | setTitle (const WString &title)
| Set a chart title.
const WString & | title () const
| Return the chart title.
void | setTitleFont (const WFont &titleFont)
| Set the font for the chart title.
const WFont & | titleFont () const
| Returns the font for the chart title.
Public Member Functions inherited from Wt::WPaintedWidget
| WPaintedWidget ()
| Create a new painted widget.
| ~WPaintedWidget ()
| Destructor.
void | setPreferredMethod (RenderMethod method)
| Sets the preferred rendering method.
RenderMethod | preferredMethod () const
| Returns the preferred rendering method.
void | update (WFlags< PaintFlag > flags=None)
| Lets the widget repaint itself.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
void | addArea (std::unique_ptr< WAbstractArea > area)
| Adds an interactive area.
void | insertArea (int index, std::unique_ptr< WAbstractArea > area)
| Inserts an interactive area.
std::unique_ptr< WAbstractArea > | removeArea (WAbstractArea *area)
| Removes an interactive area.
WAbstractArea * | area (int index) const
| Returns the interactive area at the given index.
const std::vector< WAbstractArea * > | areas () const
| Returns the interactive areas set for this widget.
JSlot & | repaintSlot ()
| A JavaScript slot that repaints the widget when triggered.
Public Member Functions inherited from Wt::WInteractWidget
| WInteractWidget ()
| Create an InteractWidget.
EventSignal< WKeyEvent > & | keyWentDown ()
| Event signal emitted when a keyboard key is pushed down.
EventSignal< WKeyEvent > & | keyPressed ()
| Event signal emitted when a "character" was entered.
EventSignal< WKeyEvent > & | keyWentUp ()
| Event signal emitted when a keyboard key is released.
EventSignal & | enterPressed ()
| Event signal emitted when enter was pressed.
EventSignal & | escapePressed ()
| Event signal emitted when escape was pressed.
EventSignal< WMouseEvent > & | clicked ()
| Event signal emitted when the primary mouse button was clicked on this widget.
EventSignal< WMouseEvent > & | doubleClicked ()
| Event signal emitted when the primary mouse button was double clicked on this widget.
EventSignal< WMouseEvent > & | mouseWentDown ()
| Event signal emitted when a mouse button was pushed down on this widget.
EventSignal< WMouseEvent > & | mouseWentUp ()
| Event signal emitted when a mouse button was released on this widget.
EventSignal< WMouseEvent > & | mouseWentOut ()
| Event signal emitted when the mouse went out of this widget.
EventSignal< WMouseEvent > & | mouseWentOver ()
| Event signal emitted when the mouse entered this widget.
EventSignal< WMouseEvent > & | mouseMoved ()
| Event signal emitted when the mouse moved over this widget.
EventSignal< WMouseEvent > & | mouseDragged ()
| Event signal emitted when the mouse is dragged over this widget.
EventSignal< WMouseEvent > & | mouseWheel ()
| Event signal emitted when the mouse scroll wheel was used.
EventSignal< WTouchEvent > & | touchStarted ()
| Event signal emitted when a finger is placed on the screen.
EventSignal< WTouchEvent > & | touchEnded ()
| Event signal emitted when a finger is removed from the screen.
EventSignal< WTouchEvent > & | touchMoved ()
| Event signal emitted when a finger, which is already placed on the screen, is moved across the screen.
EventSignal< WGestureEvent > & | gestureStarted ()
| Event signal emitted when a gesture is started.
EventSignal< WGestureEvent > & | gestureChanged ()
| Event signal emitted when a gesture is changed.
EventSignal< WGestureEvent > & | gestureEnded ()
| Event signal emitted when a gesture is ended.
void | setDraggable (const std::string &mimeType, WWidget *dragWidget=nullptr, bool isDragWidgetOnly=false, WObject *sourceWidget=nullptr)
| Configure dragging for drag and drop.
void | unsetDraggable ()
| Disable drag & drop for this widget.
void | setMouseOverDelay (int delay)
| Sets a delay for the mouse over event.
int | mouseOverDelay () const
| Returns the mouse over signal delay.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
Public Member Functions inherited from Wt::WWebWidget
| WWebWidget ()
| Construct a WebWidget.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
Signal & | childrenChanged ()
| Signal emitted when children have been added or removed.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength()) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &id) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &javascript) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
void | setLoadLaterWhenInvisible (bool)
| Change the way the widget is loaded when invisible.
std::string | htmlTagName () const
| returns the current html tag name
void | setHtmlTagName (const std::string &tag)
| set the custom HTML tag name
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
EventSignal & | blurred ()
| Signal emitted when the widget lost focus.
EventSignal & | focussed ()
| Signal emitted when the widget recieved focus.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget)
| Removes a child widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
virtual std::string | objectName () const
| Returns the object name.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
void | paintEvent (Wt::WPaintDevice *paintDevice) override
| Paints the widget.
virtual void | drawLabel (WPainter *painter, const WRectF &rect, WFlags< AlignmentFlag > alignmentFlags, const WString &text, int row) const
| drawLabel draw a label on the chart. Will be called by paint.
Protected Member Functions inherited from Wt::Chart::WAbstractChart
Protected Member Functions inherited from Wt::WPaintedWidget
WJavaScriptHandle< WTransform > | createJSTransform ()
| Create a WTransform that is accessible from JavaScript, associated with this WPaintedWidget.
WJavaScriptHandle< WBrush > | createJSBrush ()
| Create a WBrush that is accessible from JavaScript, associated with this WPaintedWidget.
WJavaScriptHandle< WPen > | createJSPen ()
| Create a WPen that is accessible from JavaScript, associated with this WPaintedWidget.
WJavaScriptHandle< WPainterPath > | createJSPainterPath ()
| Create a WPainterPath that is accessible from JavaScript, associated with this WPaintedWidget.
WJavaScriptHandle< WRectF > | createJSRect ()
| Create a WRectF that is accessible from JavaScript, associated with this WPaintedWidget.
WJavaScriptHandle< WPointF > | createJSPoint ()
| Create a WPointF that is accessible from JavaScript, associated with this WPaintedWidget.
virtual void | layoutSizeChanged (int width, int height) override
| Virtual method that indicates a size change.
virtual RenderMethod | getMethod () const
| Returns the actual method used for rendering.
virtual std::unique_ptr< WPaintDevice > | createPaintDevice () const
| Creates a paint device.
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
std::string | objJsRef () const
| Returns a JavaScript reference to the client side representation of the WPaintedWidget.
Protected Member Functions inherited from Wt::WInteractWidget
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
Protected Member Functions inherited from Wt::WWebWidget
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
virtual int | boxPadding (Orientation orientation) const
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const
| Returns the widget's built-in border width.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WWebWidget
static std::string | jsStringLiteral (const std::string &v, char delimiter='\'')
| Turn a CharEncoding::UTF8 encoded string into a JavaScript string literal.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWebWidget
Protected Types inherited from Wt::WWidget
Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A pie chart.

A pie chart renders a single data series as segments of a circle, so that the area of each segment is proportional to the value in the data series.

To use a pie chart, you need to set a model using setModel(), and use setLabelsColumn() and setDataColumn() to specify the model column that contains the category labels and data.

The pie chart may be customized visually by enabling a 3D effect (setPerspectiveEnabled()), or by specifying the angle of the first segment. One or more segments may be exploded, which separates the segment from the rest of the pie chart, using setExplode().

The segments may be labeled in various ways using setDisplayLabels().

### CSS

Styling through CSS is not applicable.

Example of a pie chart

See also
  WCartesianChart

## Member Function Documentation

## ◆ addDataPointArea()

virtual void Wt::Chart::WPieChart::addDataPointArea | ( | int | row,
|  | int | column,
|  | std::unique_ptr< WAbstractArea > | area ) const
| virtual

Adds a data point area (used for displaying e.g. tooltips).

You may want to specialize this is if you wish to modify (or delete) the area.

Note
  Currently, an area is only created if the ItemDataRole::ToolTip data at the data point is not empty.

## ◆ avoidLabelRendering()

double Wt::Chart::WPieChart::avoidLabelRendering | ( |  | ) | const

Returns the percentage to avoid label rendering.

See also
  setAvoidLabelRendering(double)

## ◆ brush()

WBrush Wt::Chart::WPieChart::brush | ( | int | modelRow | ) | const

Returns the brush used for a pie segment.

See also
  setBrush(int, const WBrush&)

## ◆ createLabelWidget()

virtual std::unique_ptr< WContainerWidget > Wt::Chart::WPieChart::createLabelWidget | ( | std::unique_ptr< WWidget > | textWidget,
|  | WPainter * | painter,
|  | const WRectF & | rect,
|  | Wt::WFlags< AlignmentFlag > | alignmentFlags ) const
| virtual

createLabelWidget possition textWidget where the text would be rendered. Assuming that textWidget is added to a container with same dimensions as the WPieChart. This should be used in combinaltion with drawLabel().

Returns
  The new WContainerWidget that contains textWidget and can be placed on an other layer that has the same dimensions as the WPieChart.

See also
  drawLabel()

Usage example, PieChart with label links.

class PChart : public Wt::Chart::WPieChart {
private:
Wt::WContainerWidget *widgetsLayer_;
public:
PChart(Wt::WContainerWidget *widgetsLayer) :
widgetsLayer_(widgetsLayer)
{
widgetsLayer_->resize(800, 300);
resize(800, 300);
widgetsLayer_->setPositionScheme(Wt::PositionScheme::Relative);
}
virtual void drawLabel(Wt::WPainter* painter, const Wt::WRectF& rect,
Wt::WFlags<Wt::AlignmentFlag> alignmentFlags,
const Wt::WString& text, int row) const
{
if (model()->link(row, dataColumn()) == 0) {
WPieChart::drawLabel(painter, rect, alignmentFlags, text, row);
} else {
auto a = std::make_unique<Wt::WAnchor>(
*model()->link(row, dataColumn()), text);
widgetsLayer_->addWidget(createLabelWidget(std::move(a), painter, rect, alignmentFlags));
}
}
};
Wt::Chart::WAbstractChart::model
std::shared_ptr< WAbstractChartModel > model() const
Returns the model.
Definition WAbstractChart.h:100
Wt::Chart::WPieChart
A pie chart.
Definition WPieChart.h:67
Wt::Chart::WPieChart::createLabelWidget
virtual std::unique_ptr< WContainerWidget > createLabelWidget(std::unique_ptr< WWidget > textWidget, WPainter *painter, const WRectF &rect, Wt::WFlags< AlignmentFlag > alignmentFlags) const
createLabelWidget possition textWidget where the text would be rendered. Assuming that textWidget is ...
Wt::Chart::WPieChart::drawLabel
virtual void drawLabel(WPainter *painter, const WRectF &rect, WFlags< AlignmentFlag > alignmentFlags, const WString &text, int row) const
drawLabel draw a label on the chart. Will be called by paint.
Wt::Chart::WPieChart::dataColumn
int dataColumn() const
Returns the model column used for the data.
Definition WPieChart.h:112
Wt::WContainerWidget
A widget that holds and manages child widgets.
Definition WContainerWidget.h:135
Wt::WContainerWidget::addWidget
virtual void addWidget(std::unique_ptr< WWidget > widget)
Adds a child widget to this container.
Wt::WFlags
Utility class for type-safe combinations of enumeration flags.
Definition WFlags.h:31
Wt::WPaintedWidget::resize
virtual void resize(const WLength &width, const WLength &height) override
Resizes the widget.
Wt::WPainter
Vector graphics painting class.
Definition WPainter.h:147
Wt::WRectF
A value class that defines a rectangle.
Definition WRectF.h:42
Wt::WString
A value class which describes a locale-aware unicode string.
Definition WString.h:74
Wt::WWebWidget::resize
virtual void resize(const WLength &width, const WLength &height) override
Resizes the widget.
Wt::WWebWidget::setPositionScheme
virtual void setPositionScheme(PositionScheme scheme) override
Sets the CSS position scheme.
Wt::PositionScheme::Relative
@ Relative
Relative position scheme.

## ◆ createLegendItemWidget()

std::unique_ptr< WWidget > Wt::Chart::WPieChart::createLegendItemWidget | ( | int | index,
|  | WFlags< LabelOption > | options )

Creates a widget which renders the a legend item.

Depending on the passed LabelOption flags, the legend item widget, will contain a text (with or without the percentage) and/or a span with the segment's color.

## ◆ dataColumn()

int Wt::Chart::WPieChart::dataColumn | ( |  | ) | const

Returns the model column used for the data.

See also
  setDataColumn(int)

## ◆ displayLabels()

WFlags< LabelOption > Wt::Chart::WPieChart::displayLabels | ( |  | ) | const

Returns options set for displaying labels.

See also
  WPieChart::setDisplayLabels()

## ◆ drawLabel()

virtual void Wt::Chart::WPieChart::drawLabel | ( | WPainter * | painter,
|  | const WRectF & | rect,
|  | WFlags< AlignmentFlag > | alignmentFlags,
|  | const WString & | text,
|  | int | row ) const
| protectedvirtual

drawLabel draw a label on the chart. Will be called by paint.

You may want to specialize this if you wish to replace the label by a widget.

See also
  createLabelWidget() if you wish to replace the label by a Widget.

## ◆ explode()

double Wt::Chart::WPieChart::explode | ( | int | modelRow | ) | const

Returns the explosion factor for a segment.

See also
  setExplode(int, double)

## ◆ isPerspectiveEnabled()

bool Wt::Chart::WPieChart::isPerspectiveEnabled | ( |  | ) | const

Returns whether a 3D effect is enabled.

See also
  setPerspectiveEnabled(bool, double)

## ◆ isShadowEnabled()

bool Wt::Chart::WPieChart::isShadowEnabled | ( |  | ) | const

Returns whether a shadow effect is enabled.

See also
  setShadowEnabled()

## ◆ labelFormat()

WString Wt::Chart::WPieChart::labelFormat | ( |  | ) | const

Returns the label format string.

See also
  setLabelFormat()

## ◆ labelsColumn()

int Wt::Chart::WPieChart::labelsColumn | ( |  | ) | const

Returns the model column used for the labels.

See also
  setLabelsColumn(int)

## ◆ paint()

virtual void Wt::Chart::WPieChart::paint | ( | WPainter & | painter,
|  | const WRectF & | rectangle = WRectF() ) const
| overridevirtual

Paint the chart in a rectangle of the given painter.

Paints the chart inside the painter, in the area indicated by rectangle. When rectangle is a null rectangle, the entire painter window is used.

Implements Wt::Chart::WAbstractChart.

## ◆ paintEvent()

void Wt::Chart::WPieChart::paintEvent | ( | Wt::WPaintDevice * | paintDevice | ) |
| overrideprotectedvirtual

Paints the widget.

You should reimplement this method to paint the contents of the widget, using the given paintDevice.

Implements Wt::WPaintedWidget.

## ◆ setAvoidLabelRendering()

void Wt::Chart::WPieChart::setAvoidLabelRendering | ( | double | percent | ) |

Sets the percentage value to avoid rendering of label texts.

The default value is 0 percent.

## ◆ setBrush()

void Wt::Chart::WPieChart::setBrush | ( | int | modelRow,
|  | const WBrush & | brush )

Customizes the brush used for a pie segment.

By default, the brush is taken from the palette(). You can use this method to override the palette's brush for a particular modelRow.

See also
  setPalette(WChartPalette *)

## ◆ setDataColumn()

void Wt::Chart::WPieChart::setDataColumn | ( | int | modelColumn | ) |

Sets the model column that holds the data.

The data column should contain data that can be converted to a number, but should not necessarily be of a number type, see also asNumber(const boost::any&).

The default value is -1 (not defined).

See also
  setModel(WAbstractItemModel *), setLabelsColumn(int)

## ◆ setDisplayLabels()

void Wt::Chart::WPieChart::setDisplayLabels | ( | WFlags< LabelOption > | options | ) |

Configures if and how labels should be displayed.

The options must be the logical OR of a placement option (LabelOption::Inside or LabelOption::Outside) and LabelOption::TextLabel and/or LabelOption::TextPercentage. If both LabelOption::TextLabel and LabelOption::TextPercentage are specified, then these are combined as "<label>: <percentage>".

The default value is LabelOption::None.

## ◆ setExplode()

void Wt::Chart::WPieChart::setExplode | ( | int | modelRow,
|  | double | factor )

Sets the explosion factor for a pie segment.

Separates the segment corresponding to model row modelRow from the rest of the pie. The factor is a positive number that represents the distance from the center as a fraction of the pie radius. Thus, 0 corresponds to no separation, and 0.1 to a 10% separation, and 1 to a separation where the segment tip is on the outer perimeter of the pie.

The default value is 0.

## ◆ setLabelFormat()

void Wt::Chart::WPieChart::setLabelFormat | ( | const WString & | format | ) |

Sets the label format.

Sets a format string which is used to format label (percentage) values.

The format string must be a format string that is accepted by snprintf() and which formats one double. If the format string is an empty string, then WLocale::toString() is used.

The default value is "%.3g%%".

See also
  labelFormat()

## ◆ setLabelsColumn()

void Wt::Chart::WPieChart::setLabelsColumn | ( | int | column | ) |

Sets the model column that holds the labels.

The labels are used only when setDisplayLabels() is called with the LabelOption::TextLabel option.

The default value is -1 (not defined).

See also
  setModel(WAbstractItemModel *), setDisplayLabels(), setDataColumn(int)

## ◆ setPerspectiveEnabled()

void Wt::Chart::WPieChart::setPerspectiveEnabled | ( | bool | enabled,
|  | double | height = 1.0 )

Enables a 3D perspective effect on the pie.

A 3D perspective effect is added, which may be customized by specifying the simulated height of the pie. The height is defined as a fraction of the pie radius.

The default value is false.

## ◆ setShadowEnabled()

void Wt::Chart::WPieChart::setShadowEnabled | ( | bool | enabled | ) |

Enables a shadow effect.

A soft shadow effect is added.

The default value is false.

## ◆ setStartAngle()

void Wt::Chart::WPieChart::setStartAngle | ( | double | degrees | ) |

Sets the angle of the first segment.

The default value is 45 degrees.

## ◆ startAngle()

double Wt::Chart::WPieChart::startAngle | ( |  | ) | const

Returns the angle of the first segment.

See also
  setStartAngle(double)